﻿
/*
 * 用法：  GR.getArriveTimeArray(GuaranteeRuleObj,Hotel)
 */

var GRMAIN = function () {


    var HOTEL_DB_NONE = 0;
    var HOTEL_DB_MUST = 1;
    var HOTEL_DB_AMOUNT = 2;
    var HOTEL_DB_TIME = 3;
    var HOTEL_DB_AMOUNTANDTIME = 4;
    var HOTEL_PAY = 5;
    var m_isSelfPay = false;

    var m_dbDict = null;

    var m_inDate = "2014-09-10";
    var m_outDate = "2014-09-10";
    var m_orderNum = 2;//预订房间数量
    var m_bArriveDate = "2014-09-10";
    var m_lArriveDate = "2014-09-28";

    var G_CheckInDay = "CHECKINDAY";
    var G_StayDay = "STAYDAY";



    //酒店担保类型
    //define HOTEL_DB_NONE              0    //NONE
    //define HOTEL_DB_MUST              1    //无条件担保
    //define HOTEL_DB_AMOUNT            2    //超房担保
    //define HOTEL_DB_TIME              3    //超时担保
    //define HOTEL_DB_AMOUNTANDTIME     4    //超时超房担保
    //define HOTEL_PAY                  5    //预付



    //根据传入日期字符串返回对应时间字符串数组
    function getNoneArriveHotelTimeArray(dateStr) {
        var d = null;
        if (dateStr != "" && dateStr != null) {
            d = new Date(dateStr);
        } else {
            d = new Date();
        }
        var currentHour = d.getHours();
        var hashMap = {}; //键值对对象
        //11 19 23 0
        if (currentHour <= 11) {
            hashMap["12:00"] = "12:00之前";
        }
        if (currentHour < 19) {
            hashMap["20:00"] = "20:00之前";
        }
        if (currentHour < 23) {
            hashMap["23:59"] = "23:59之前";
        }
        if (currentHour >= 0) {
            hashMap["06:00"] = "次日凌晨06:00之前";
        }
        return hashMap;
    }

    //根据担保条件规则返回相应的值
    function getArriveHotelTimeArray_MUSTDB(rDictStr) {
        if (rDictStr != "" && rDictStr != null) {
            var isDB = TestIsInDBDate(rDictStr);
            var hashMap = {}; //键值对对象
            if (isDB) {
                hashMap["06:00"] = "整晚保留";
                return hashMap;
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

    //宣琳出场=====
    function formatInitDate(timestr) {
        var cdate = new Date(timestr);
        var datetime = cdate.getHours() * 10000 + cdate.getMinutes() * 100 + cdate.getSeconds();
        return datetime;
    }

    function timeIntervalBetweenDate(startdate, enddate) {
        return 0;
    }

    function timeIntervalSince1970(date) {
        var date1970 = new Date("1970-01-01");
        var result = -date1970.getTime() + date;
        return result;
    }

    //超时超房担保
    function getArriveHotelTimeArray_AMOUNTANDTIME(rDictStr) {
        //判空
        if (rDictStr == null || rDictStr == "") return getNoneArriveHotelTimeArray();

        var szArray = {};
        var isDB = TestIsInDBDate(rDictStr);

        if (isDB) {
            //首先看是否超房
            var rDictObject = rDictStr;
            var Amount = rDictObject.Amount == "" ? 0 : parseInt(rDictObject.Amount);
            if (m_orderNum >= Amount) {
                //要担保
                szArray["06:00"] = "整晚保留";
                return szArray;
            } else {
                //查看是否是超时
                return getArriveHotelTimeArray_TIME(rDictStr);
            }

        } else {
            return getNoneArriveHotelTimeArray();
        }

        return szArray;
    }

    //判断idate是否在sDate与eDate里面
    function isInDateTimeSpe(iDate, sDate, eDate) {

        iDate = new Date(iDate).valueOf();
        sDate = new Date(sDate).valueOf();
        eDate = new Date(eDate).valueOf();

        var iTime = timeIntervalSince1970(iDate);
        var sTime = timeIntervalSince1970(sDate);
        var eTime = timeIntervalSince1970(eDate);

        if (iTime >= sTime && iTime <= eTime) {
            return true;
        }
        return false;
    }


    function TestIsInWeekSet(rDictStr, jDate, cDate) {
        jDate = jDate.toString().replace(/-/g, "/");
        cDate = cDate.toString().replace(/-/g, "/");
        //判空
        if (rDictStr == null || rDictStr == "") return false;
        //console.log("rDictStr:" + rDictStr);
        //rDictStr = JSON.
        //var rDictObject = JSON.parse(rDictStr);
        rDictObject = rDictStr;
        var WeekSet = rDictObject.WeekSet;
        var DateType = rDictObject.DateType;
        if (G_CheckInDay == DateType.toUpperCase()) {
            //var cdates = new Date(jDate);
            var cdates = new Date(jDate);
            var week = cdates.getDay();
            if (week == 0) {
                week = 7;
            }
            if (WeekSet.indexOf(week) >= 0)
                return true;
            else
                return false;
        } else {
            var inDate = new Date(jDate);
            var date = (new Date(cDate)).valueOf();
            date -= 1000 * 3600 * 24;
            var outDate = new Date(date);
            //var outDateVal = timeIntervalSince1970(date);

            var StartDate = rDictObject.StartDate.replace(/-/g, "/");
            var sysSDate = StartDate;
            var EndDate = rDictObject.EndDate.replace(/-/g, "/");
            var sysEDate = EndDate;

            var tempDate = inDate;
            var iDate = jDate;
            //var tempDateVal = timeIntervalSince1970(iDate);

            var tempDateVal = tempDate.getTime();
            var outDateVal = outDate.getTime();
            //cc出场

            while (outDateVal >= tempDateVal) {
                var week = tempDate.getDay();
                if (week == 0) {
                    week = 7;
                }

                if (isInDateTimeSpe(iDate, sysSDate, sysEDate)) {
                    if (WeekSet.indexOf(week) >= 0)
                        return true;
                }

                iDate = new Date(iDate).valueOf();
                iDate += 1000 * 24 * 3600;
                tempDateVal = timeIntervalSince1970(iDate);
                tempDate = new Date(iDate);
            }
        }
        return false;
    }

    function testIsInDBFunc(rDictStr, jDate, cDate) {

        //判空
        if (rDictStr == null || rDictStr == "") return false;

        //判断是否在weekset里面
        if (!TestIsInWeekSet(rDictStr, jDate, cDate)) return false;

        var DateType = rDictObject.DateType;
        if (G_CheckInDay == DateType.toUpperCase()) {
            //到店
            var inTimeVal = timeIntervalSince1970(new Date(jDate.substr(0, 10).replace(/-/g, "/")).valueOf());

            var StartDate = rDictObject.StartDate.replace(/-/g, "/");
            var EndDate = rDictObject.EndDate.replace(/-/g, "/");

            var sDate = StartDate;
            var eDate = EndDate;

            var sDateVal = timeIntervalSince1970(new Date(sDate).valueOf());
            var eDateVal = timeIntervalSince1970(new Date(eDate).valueOf());

            if (inTimeVal >= sDateVal && inTimeVal <= eDateVal) {
                //要担保
                return true;
            }
            else {
                return false;
            }
        } else {
            //在店
            var inTimeVal = timeIntervalSince1970(new Date(jDate.substr(0, 10).replace(/-/g, "/")).valueOf());
            var pDate = (new Date(cDate.substr(0, 10).replace(/-/g, "/"))).valueOf();
            pDate -= 24 * 3600 * 1000;
            var outTimeVal = timeIntervalSince1970(pDate);

            var StartDate = rDictObject.StartDate.replace(/-/g, "/");
            var EndDate = rDictObject.EndDate.replace(/-/g, "/");

            var sDate = StartDate;
            var eDate = EndDate;

            var sDateVal = timeIntervalSince1970(new Date(sDate.substr(0, 10).replace(/-/g, "/")).valueOf());
            var eDateVal = timeIntervalSince1970(new Date(eDate.substr(0, 10).replace(/-/g, "/")).valueOf());

            if (inTimeVal <= eDateVal && outTimeVal >= sDateVal) {
                //在时间节点内，要担保
                return true;
            }
            else {
                return false;
            }
        }
        return false;
    }

    function TestIsInDBDate(rDictStr) {
        return testIsInDBFunc(rDictStr, m_inDate, m_outDate);
    }

    function getArriveHotelTimeArray(dbType, rDictStr) {

        var date = new Date();
        m_dbType = dbType;

        var nowTime = date.valueOf();
        var szArray = {};

        if (dbType == HOTEL_DB_MUST) {
            return getArriveHotelTimeArray_MUSTDB(rDictStr);
        }
        else if (dbType == HOTEL_PAY) {
            return getArriveHotelTimeArray_PAY(rDictStr);
        }
        else if (dbType == HOTEL_DB_AMOUNT) {
            return getArriveHotelTimeArray_AMOUT(rDictStr);
        }
        else if (dbType == HOTEL_DB_TIME) {
            return getArriveHotelTimeArray_TIME(rDictStr);
        }
        else if (dbType == HOTEL_DB_AMOUNTANDTIME) {
            return getArriveHotelTimeArray_AMOUNTANDTIME(rDictStr);
        }
        else {
            if (!TestCheckInDateEquieCurrentDate()) {
                //展示所有日期
                var inDate = formatInitDate(m_inDate);
                return getNoneArriveHotelTimeArray(inDate);
            }
            else {
                return getNoneArriveHotelTimeArray(date);
            }
        }
        return szArray;
    }

    //==宣琳收 场

    //该方法没有意义将其省略
    //getArriveHotelTimeArray_PAY:(NSDictionary *)rDict
    function getArriveHotelTimeArray_PAY(rDictStr){
        var dict = {};
        dict["06:00"] = "整晚保留";
        return dict;
    }

    //检查购买数量
    function getArriveHotelTimeArray_AMOUT(rDictStr) {
        if (rDictStr != null && rDictStr != "") {
            var rDictObject = rDictStr;
            var Amount = rDictObject.Amount == "" ? 0 : parseInt(rDictObject.Amount);
            if (m_orderNum >= Amount) {
                var hashMap = {}; //键值对对象
                hashMap["06:00"] = "整晚保留";
                return hashMap;
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

    //查看入住时间是不是与当前时间在同一天
    function TestCheckInDateEquieCurrentDate() {
        var inDate = new Date(m_inDate);
        var nowDate = new Date();
        if (inDate != null) {
            if (inDate.getFullYear() == nowDate.getFullYear() && inDate.getMonth() == nowDate.getMonth() && inDate.getDate() == nowDate.getDate()) {
                return true;
            }
        }
        return false;
    }

    //主方法【获取时间信息】
    function getArriveTimeArray(roomDicts, hotel) {
        //查看当前的担保规则的类型，并不表示当前的房间就是在担保规则里

        roomDicts = decodeURIComponent(roomDicts);
        hotel = decodeURIComponent(hotel);
        //console.log(JSON.parse(hotel));

        //成员变量初始化
        m_orderNum = JSON.parse(hotel) == null ? 0 : JSON.parse(hotel).RoomNum;
        m_isSelfPay = JSON.parse(hotel) == null ? 0 : JSON.parse(hotel).isSelfPay;
        m_outDate = JSON.parse(hotel).CheckOutDate;
        m_inDate = JSON.parse(hotel).CheckInDate;
        m_bArriveDate = JSON.parse(hotel).bArriveDate;
        m_lArriveDate = JSON.parse(hotel).lArriveDate;
        //console.log("输入的酒店信息:" + m_orderNum + "," + m_isSelfPay + "," + m_outDate + "," + m_inDate + "," + m_bArriveDate);
        var roomDict = null;
        if(roomDicts&&roomDicts!=""){
        	roomDict = JSON.parse(roomDicts);
        }
        //console.log(roomDict);
        var dbType = HOTEL_DB_NONE;
        var dbDict = null;
        if (roomDict != null) {
            var amount = 0;
            var sDate = null;
            for (var i = 0; i < roomDict.GuaranteeRules.length; i++) {
                var szDict = roomDict.GuaranteeRules[i];
                if (szDict != null) {
                    var IsAmountGuarantee = szDict.IsAmountGuarantee;
                    var IsTimeGuarantee = szDict.IsTimeGuarantee;
                    if (!IsAmountGuarantee && !IsTimeGuarantee) {
                        //无条件担保
                        var isDB = TestIsInDBDate(szDict);
                        if (isDB) {
                            dbType = HOTEL_DB_MUST;
                            dbDict = szDict;
                            break;
                        }
                    }

                    if (IsAmountGuarantee && !IsTimeGuarantee) {
                        //超房担保
                        var isDB = TestIsInDBDate(szDict);
                        if (isDB) {
                            var tempMount = parseInt(szDict.Amount);
                            if (m_orderNum >= tempMount) {
                                if (amount == 0) {
                                    dbType = HOTEL_DB_AMOUNT;
                                    amount = tempMount;
                                    dbDict = szDict;
                                }
                                else {
                                    if (tempMount < amount) {
                                        dbType = HOTEL_DB_AMOUNT;
                                        amount = tempMount;
                                        dbDict = szDict;
                                    }
                                }
                            }
                        }
                    }

                    if (!IsAmountGuarantee && IsTimeGuarantee) {
                        if (dbType == HOTEL_DB_NONE || dbType == HOTEL_DB_TIME || dbType == HOTEL_DB_AMOUNTANDTIME) {
                            var isDB = TestIsInDBDate(szDict);
                            if (isDB) {
                                var StartTime = szDict.StartTime;
                                var StartTimeNow = new Date(szDict.StartDate + " " + StartTime);
                                var szDate = StartTimeNow;
                                if (sDate == null) {
                                    dbType = HOTEL_DB_TIME;
                                    sDate = szDate;
                                    dbDict = szDict;
                                }
                                else {
                                    if (timeIntervalSinceDate(sDate) < 0) {
                                        dbType = HOTEL_DB_TIME;
                                        sDate = szDate;
                                        dbDict = szDict;
                                    }
                                }
                            }
                        }
                    }

                    if (IsAmountGuarantee && IsTimeGuarantee) {
                        if (dbType == HOTEL_DB_NONE || dbType == HOTEL_DB_TIME || dbType == HOTEL_DB_AMOUNTANDTIME) {
                            var isDB = TestIsInDBDate(szDict);
                            if (isDB) {
                                var tempMount = parseInt(szDict.Amount);
                                if (amount == 0) {
                                    dbType = HOTEL_DB_AMOUNTANDTIME;
                                    amount = tempMount;
                                    dbDict = szDict;
                                }
                                else {
                                    if (tempMount < amount) {
                                        dbType = HOTEL_DB_AMOUNTANDTIME;
                                        amount = tempMount;
                                        dbDict = szDict;
                                    }
                                }

                                var StartTime = szDict.StartTime;
                                var StartTimeNow = new Date(szDict.StartDate + " " + StartTime);
                                var szDate = StartTimeNow;
                                if (sDate == null) {
                                    dbType = HOTEL_DB_AMOUNTANDTIME;
                                    sDate = szDate;
                                    dbDict = szDict;
                                }
                                else {
                                    if (timeIntervalSinceDate(sDate) < 0) {
                                        dbType = HOTEL_DB_AMOUNTANDTIME;
                                        sDate = szDate;
                                        dbDict = szDict;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        if (!m_isSelfPay) {
            dbType = HOTEL_PAY;
        }
        //return "{\"result\":0, \"msg\":\"OK\", \"type\":"+dbType+", \"param\":\""+sDate+"\"}";
        //return dbDict;
        var ArriveHotelList = getArriveHotelTimeArray(dbType, dbDict);
        var strResult = "{\"result\":0, \"msg\":\"OK\", \"time\":[";
        for (var key in ArriveHotelList) {
            strResult += "{\"" + key + "\":" + "\"" + ArriveHotelList[key] + "\"},";
            ////console.log("map["+key+"]:"+ArriveHotelList[key]);  
        }
        strResult = strResult.substr(0, strResult.length - 1);
        strResult += "],\"GuaranteeRule\":" + JSON.stringify(dbDict) + "}";

        //return getArriveHotelTimeArray(dbType, dbDict);
      //  //console.log(dbDict)
        return strResult;
    }

    //主方法获取担保规则
    function getGuaranteeJSResult(roomDicts, hotel) {
        //查看当前的担保规则的类型，并不表示当前的房间就是在担保规则里

        roomDicts = decodeURIComponent(roomDicts);
        hotel = decodeURIComponent(hotel);
        //console.log(JSON.parse(hotel));

        //成员变量初始化
        //console.log(JSON.parse(hotel));
        m_orderNum = JSON.parse(hotel) == null ? 0 : JSON.parse(hotel).RoomNum;
        m_isSelfPay = JSON.parse(hotel) == null ? 0 : JSON.parse(hotel).isSelfPay;
        m_outDate = JSON.parse(hotel).CheckOutDate;
        m_inDate = JSON.parse(hotel).CheckInDate;
        m_bArriveDate = JSON.parse(hotel).bArriveDate;
        m_lArriveDate = JSON.parse(hotel).lArriveDate;
        //console.log("输入的酒店信息:" + m_orderNum + "," + m_isSelfPay + "," + m_outDate + "," + m_inDate + "," + m_bArriveDate);
        var roomDict = null;
        if(roomDicts && roomDicts != ""){
        	roomDict = JSON.parse(roomDicts);
        }
        var dbType = HOTEL_DB_NONE;
        var dbDict = null;
        if (roomDict != null) {
            var amount = 0;
            var sDate = null;
            for (var i = 0; i < roomDict.GuaranteeRules.length; i++) {
                var szDict = roomDict.GuaranteeRules[i];
                if (szDict != null) {
                    var IsAmountGuarantee = szDict.IsAmountGuarantee;
                    var IsTimeGuarantee = szDict.IsTimeGuarantee;
                    if (!IsAmountGuarantee && !IsTimeGuarantee) {
                        //无条件担保
                        var isDB = TestIsInDBDate(szDict);
                        if (isDB) {
                            dbType = HOTEL_DB_MUST;
                            dbDict = szDict;
                            break;
                        }
                    }

                    if (IsAmountGuarantee && !IsTimeGuarantee) {
                        //超房担保
                        var isDB = TestIsInDBDate(szDict);
                        if (isDB) {
                            var tempMount = parseInt(szDict.Amount);
                            if (m_orderNum >= tempMount) {
                                if (amount == 0) {
                                    dbType = HOTEL_DB_AMOUNT;
                                    amount = tempMount;
                                    dbDict = szDict;
                                }
                                else {
                                    if (tempMount < amount) {
                                        dbType = HOTEL_DB_AMOUNT;
                                        amount = tempMount;
                                        dbDict = szDict;
                                    }
                                }
                            }
                        }
                    }

                    if (!IsAmountGuarantee && IsTimeGuarantee) {
                        if (dbType == HOTEL_DB_NONE || dbType == HOTEL_DB_TIME || dbType == HOTEL_DB_AMOUNTANDTIME) {
                            var isDB = TestIsInDBDate(szDict);
                            if (isDB) {
                                var StartTime = szDict.StartTime;
                                var StartTimeNow = new Date(szDict.StartDate.replace(/-/g, "/") + " " + StartTime);
                                var szDate = StartTimeNow;
                                if (sDate == null) {
                                    dbType = HOTEL_DB_TIME;
                                    sDate = szDate;
                                    dbDict = szDict;
                                }
                                else {
                                    if (timeIntervalSinceDate(sDate) < 0) {
                                        dbType = HOTEL_DB_TIME;
                                        sDate = szDate;
                                        dbDict = szDict;
                                    }
                                }
                            }
                        }
                    }

                    if (IsAmountGuarantee && IsTimeGuarantee) {
                        if (dbType == HOTEL_DB_NONE || dbType == HOTEL_DB_TIME || dbType == HOTEL_DB_AMOUNTANDTIME) {
                            var isDB = TestIsInDBDate(szDict);
                            if (isDB) {
                                var tempMount = parseInt(szDict.Amount);
                                if (amount == 0) {
                                    dbType = HOTEL_DB_AMOUNTANDTIME;
                                    amount = tempMount;
                                    dbDict = szDict;
                                }
                                else {
                                    if (tempMount < amount) {
                                        dbType = HOTEL_DB_AMOUNTANDTIME;
                                        amount = tempMount;
                                        dbDict = szDict;
                                    }
                                }

                                var StartTime = szDict.StartTime;
                                var StartTimeNow = new Date(szDict.StartDate.replace(/-/g, "/") + " " + StartTime);
                                var szDate = StartTimeNow;
                                if (sDate == null) {
                                    dbType = HOTEL_DB_AMOUNTANDTIME;
                                    sDate = szDate;
                                    dbDict = szDict;
                                }
                                else {
                                    if (timeIntervalSinceDate(sDate) < 0) {
                                        dbType = HOTEL_DB_AMOUNTANDTIME;
                                        sDate = szDate;
                                        dbDict = szDict;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        //console.log("担保规则：" + dbDict + ",类型:" + dbType);
        var result = testIsDB(dbType, dbDict);
        var resultCode = 1;
        if (result == true) {
            resultCode = 0;
        }

        var showMsg = getCancelNoticeInGuaranteeSource(dbDict);
        var resultStr = "{\"result\":" + resultCode + ", \"msg\":\"\", \"type\":" + dbType + ",\"showMsg\":\"" + showMsg + "\",\"GuaranteeRule\":" + JSON.stringify(dbDict) + "}";
        return resultStr;
    }


    function testIsDB(dbType, rDict) {
        //判断是否要担保

        if (dbType == HOTEL_DB_MUST) {
            m_dbDict = rDict;
            return true;
        }
        else if (dbType == HOTEL_PAY) {
            m_dbDict = rDict;
            return false;
        }
        else if (dbType == HOTEL_DB_AMOUNT) {
            var ret = isAmountDB(rDict);
            if (ret) {
                m_dbDict = rDict;
            }
            return ret;
        }
        else if (dbType == HOTEL_DB_TIME) {
            //是否超时担保
            var ret = isTimeDB(rDict);
            if (ret) {
                m_dbDict = rDict;
            }
            return ret;
        }
        else if (dbType == HOTEL_DB_AMOUNTANDTIME) {
            //首先看是否超房
            if (isAmountDB(rDict)) {
                m_dbDict = rDict;
                return true;
            }

            //是否超时担保
            var ret = isTimeDB(rDict);
            if (ret) {
                m_dbDict = rDict;
            }
            return ret;
        }
        else {
            return false;
        }
        return false;
    }

    function isTimeDB(rDict) {
        var m_inDates = new Date(m_inDate.replace(/-/g, "/"));


        var fsDate = new Date(rDict.StartDate.replace(/-/g, "/") + " " + rDict.StartTime);

        //设置时分秒
        m_inDates.setHours(fsDate.getHours());
        m_inDates.setMinutes(fsDate.getMinutes());
        m_inDates.setSeconds(fsDate.getSeconds());

        fsDate = m_inDates;

        var m_inDates2 = new Date(m_inDate.replace(/-/g, "/"));
        var esDate = new Date(rDict.EndDate.replace(/-/g, "/") + " " + rDict.EndTime);
        m_inDates2.setHours(esDate.getHours());
        m_inDates2.setMinutes(esDate.getMinutes());
        m_inDates2.setSeconds(esDate.getSeconds());
        esDate = m_inDates2;

        var IsTomorrow = rDict.IsTomorrow;

        var fsDateTS = fsDate.getTime();
        var esDateTS = esDate.getTime();

        var lArriveDate = new Date(m_lArriveDate.replace(/-/g, "/"));
        var m_inDateTS = lArriveDate.getTime();
        if (IsTomorrow == 1) {
            esDateTS = esDateTS + 24 * 3600 * 1000;
        }

        if (m_inDateTS > fsDateTS && m_inDateTS <= esDateTS) {
            //要担保
            return true;
        }
        else {
            return false;
        }
    }

    function isAmountDB(rDict) {
        var Amount = parseInt(rDict.Amount);
        if (m_orderNum >= Amount) {
            //要担保
            return true;
        }
        else {
            return false;
        }
    }

    //担保取消规则
    function getCancelNoticeInGuaranteeSource(m_dbDictStr) {

        //m_bArriveDate到店时间需要传递过来
        //m_inDate入住时间需要传递过来
        m_dbDict = m_dbDictStr;
        if (m_dbDict) {
            var szDict = m_dbDict;
            if (szDict != null) {
                var ChangeRule = m_dbDict.ChangeRule;
                if (ChangeRule != "") {
                    if (ChangeRule.indexOf("NoChange") >= 0) {
                        var tempText = "不允许变更取消。";
                        //tempText += "(NoChange)";
                        return tempText;
                    }
                    else if (ChangeRule.indexOf("NeedSomeDay") >= 0) {
                        var Day = szDict.Day;
                        var Time = szDict.Time;
                        var tempText = "如需取消或修改本次预订，请您务必于" + Day + "日" + Time + "时前致电400-678-5151提出变更。";
                        //tempText += "(NeedSomeDay)";
                        return tempText;
                    }
                    else if (ChangeRule.indexOf("NeedCheckinTime") >= 0) {
                        var hour = parseInt(szDict.Hour);
                        hour = hour * 3600 * 1000;
                        //对23：59分的情况进行特别处理
                        var m_bArriveDateNow = new Date(m_bArriveDate.replace(/-/g, "/"));

                        if (m_bArriveDateNow.getHours() == 23 && m_bArriveDateNow.getMinutes() == 59) {
                            hour = hour - (59 * 1000);
                            //m_bArriveDateNow.setHours(hour);
                        }
                        var date = m_bArriveDateNow.getTime();
                        date -= hour;
                        m_bArriveDateNow = new Date(date);

                        var timeText = m_bArriveDateNow.getFullYear() + "-" + ((m_bArriveDateNow.getMonth() + 1) < 10 ? ("0" + (m_bArriveDateNow.getMonth() + 1)) : ((m_bArriveDateNow.getMonth() + 1))) + "-" + (m_bArriveDateNow.getDate() < 10 ? ("0" + m_bArriveDateNow.getDate()) : (m_bArriveDateNow.getDate()));
                        var tempText = "如需取消或修改本次预订，请您务必于" + timeText + "日" + m_bArriveDateNow.getHours() + "时" + m_bArriveDateNow.getMinutes() + "分前致电400-678-5151提出变更。";//(NeedCheckinTime)
                        return tempText;
                    }
                    else if (ChangeRule.indexOf("NeedCheckin24hour") >= 0) {
                        var hour = parseInt(szDict.Hour);
                        hour = (hour * 3600 - 60) * 1000;
                        if (hour < 0) hour = 0;
                        var m_inDateDate = m_inDate.substr(0, 10);
                        var newDate = new Date(m_inDateDate.replace(/-/g, "/") + " 23:59:59");
                        //时间相加计算
                        var date = newDate.getTime();
                        date -= hour;
                        var futureDate = new Date(date);
                        var timeText = futureDate.getFullYear() + "-" + ((futureDate.getMonth() + 1) < 10 ? ("0" + (futureDate.getMonth() + 1)) : (futureDate.getMonth() + 1)) + "-" + (futureDate.getDate() < 10 ? ("0" + futureDate.getDate()) : futureDate.getDate());
                        var tempText = "如需取消或修改本次预订，请您务必于" + timeText + "日" + futureDate.getHours() + "时" + futureDate.getMinutes() + "分前致电400-678-5151提出变更。";//(NeedCheckin24hour)
                        return tempText;
                    }
                }
            }
        }
        return "";
    }

    function getCancelNoticeInGuarantee(m_dbDictStr, hotel, ChangeRules) {
        var str = getCancelNoticeInGuaranteeSource(m_dbDictStr, hotel, ChangeRules);
        return "{\"result\":0, \"msg\":\"" + str + "\"}";
    }


    function timeIntervalSinceDate(sdate) {
        return 1;
    }
    //超时担保
    function getArriveHotelTimeArray_TIME(rDict) {
        if (rDict == null) return getNoneArriveHotelTimeArray();

        //BOOL isDB = [self TestIsInDBDate:rDict];
        var isDB = TestIsInDBDate(rDict);
        if (isDB) {

            //查看入住时间是不是与当前时间在同一天，如果不在同一天，则都必须显示
            var isTrank = false;
            var StartTime = rDict.StartTime;
            //NSString * StartTime = [rDict objectForKey:@"StartTime"];
            var timeDate = new Date(rDict.StartDate + " " + StartTime);
            var dateNow = new Date();

            var preDate = new Date(timeDate.valueOf() - 3600 * 1000);
            preDate.setFullYear(dateNow.getFullYear());
            preDate.setMonth(dateNow.getMonth());
            preDate.setDate(dateNow.getDate());

            var valTime = dateNow.getTime() - preDate.getTime();

            if (!TestCheckInDateEquieCurrentDate()) {
                isTrank = true;
            }
            else {
                if (valTime <= 0) {
                    isTrank = true;
                }
            }

            var hashMap = {};
            if (isTrank) {
                //还未过时
                var nextDate = timeDate;
                nextDate.setSeconds(0);
                var catTime = (nextDate.getHours() < 10 ? ("0" + nextDate.getHours()) : nextDate.getHours()) + ":" + (nextDate.getMinutes() < 10 ? ("0" + nextDate.getMinutes()) : nextDate.getMinutes()) + "之前";
                var realTime = (nextDate.getHours() < 10 ? ("0" + nextDate.getHours()) : nextDate.getHours()) + ":" + (nextDate.getMinutes() < 10 ? ("0" + nextDate.getMinutes()) : nextDate.getMinutes());

                hashMap[realTime] = catTime;
            }

            hashMap["06:00"] = "次日凌晨06:00之前";

            return hashMap;
        }
        else {
            return getNoneArriveHotelTimeArray();
        }
    }

    function getRightDBDictAndType(roomDict, jDate, cDate) {
        //查看当前的担保规则的类型，并不表示当前的房间就是在担保规则里
        roomDict = JSON.parse(roomDict);
        if (roomDict && roomDict.GuaranteeRules && roomDict.GuaranteeRules.length > 0) {
            for (var i = 0; i < roomDict.GuaranteeRules.length; i++) {
                var szDict = roomDict.GuaranteeRules[i];
                if (szDict) {
                    var IsAmountGuarantee = szDict.IsAmountGuarantee;
                    var IsTimeGuarantee = szDict.IsTimeGuarantee;

                    if (!IsAmountGuarantee && !IsTimeGuarantee) {
                        //无条件担保
                        var isDB = testIsInDBFunc(szDict, jDate.substr(0, 10).replace(/-/g, "/"), cDate.substr(0, 10).replace(/-/g, "/"));
                        if (isDB) {
                            return "{\"result\":0, \"msg\":\"OK\"}";
                        }
                    }
                }
            }
        }
        return "{\"result\":1}";
    }


    //查看当前的是否符合无条件担保的规则
    function testRoomHaveNoConGuarantee(roomDict, jDate, cDate) {
        roomDict = decodeURIComponent(roomDict);
        if (roomDict) {
            var szResult = getRightDBDictAndType(roomDict, (jDate.substr(0, 10)).replace(/-/g, "/"), (cDate.substr(0, 10)).replace(/-/g, "/"));
            return szResult;
        }
        return "{\"result\":1}";
    }

    return {
        getArriveTimeArray: function (roomDicts, hotel) {
            return getArriveTimeArray(roomDicts, hotel)
        },
        getGuaranteeJSResult: function (roomDicts, hotel) {
            return getGuaranteeJSResult(roomDicts, hotel)
        },
        testRoomHaveNoConGuarantee: function (roomDict, jDate, cDate) {
            return testRoomHaveNoConGuarantee(roomDict, jDate, cDate);
        }
    }
}

var GR = new GRMAIN;

